require "import"
import "android.media.AudioManager"
import "android.content.Context"
import "android.provider.Settings" -- استيراد Settings
import "android.content.ComponentName"
import "android.content.Context"
import "android.content.Intent"
import "android.media.AudioManager"
import "android.provider.Settings"
import "android.widget.Button"
import "android.widget.LinearLayout"
import "android.widget.SeekBar"
import "android.widget.TextView"
import "com.androlua.LuaDialog"


context = activity or service
audioManager = context.getSystemService(Context.AUDIO_SERVICE)

function getPhoneMode()
  local mode = audioManager.getRingerMode()
  if mode == AudioManager.RINGER_MODE_SILENT then
    return "Silent"
  elseif mode == AudioManager.RINGER_MODE_VIBRATE then
    return "Vibrate"
  elseif mode == AudioManager.RINGER_MODE_NORMAL then
    return "Normal"
  else
    return "Unknown"
  end
end

function setVolume(streamType, progress)
  audioManager.setStreamVolume(streamType, progress, 0)
end

-- تعديل الدالة setSoundMode لضبط حالة audio mode أو الاهتزاز
function setSoundMode(mode)
  currentMode = audioManager.getRingerMode()
  if mode == "vibrate" and currentMode ~= AudioManager.RINGER_MODE_VIBRATE then
    audioManager.setRingerMode(AudioManager.RINGER_MODE_VIBRATE)
  elseif mode == "ring" and currentMode ~= AudioManager.RINGER_MODE_NORMAL then
    audioManager.setRingerMode(AudioManager.RINGER_MODE_NORMAL)
  elseif mode == "silent" and currentMode ~= AudioManager.RINGER_MODE_SILENT then
    audioManager.setRingerMode(AudioManager.RINGER_MODE_SILENT)
  end
end

function initializeSeekBar(seekBar, streamType)
  maxVolume = audioManager.getStreamMaxVolume(streamType)
  currentVolume = audioManager.getStreamVolume(streamType)

  seekBar.setMax(maxVolume)
  seekBar.setProgress(currentVolume)

  seekBar.setOnSeekBarChangeListener(luajava.createProxy("android.widget.SeekBar$OnSeekBarChangeListener", {
    onProgressChanged = function(seekBar, progress, fromUser)
      if fromUser then
        setVolume(streamType, progress)
      end
    end,
    onStartTrackingTouch = function(seekBar) end,
    onStopTrackingTouch = function(seekBar) end,
  }))
end

function togglePhoneMode()
  local currentMode = audioManager.getRingerMode()
  if currentMode == AudioManager.RINGER_MODE_NORMAL then
    setSoundMode("vibrate")
    service.postSpeak(500, "Phone mode: Vibrate")
  elseif currentMode == AudioManager.RINGER_MODE_VIBRATE then
    setSoundMode("silent")
    service.postSpeak(500, "Phone mode: Silent")
  else
    setSoundMode("ring")
    service.postSpeak(500, "Phone mode: Normal")
  end
end

layout = {
  LinearLayout,
  layout_width = "match_parent",
  layout_height = "match_parent",
  orientation = 1,

  {
    LinearLayout,
    orientation = 0,
    layout_width = "match_parent",

    {
      TextView,
      id = "textview",
      text = "System audio",
      onClick = function(v)
dlg.dismiss()
        require 'import'
        import "android.content.*"

        -- تعريف النية (Intent)
        i = Intent()
        i.setAction(Settings.ACTION_SOUND_SETTINGS) -- تحديد الإعدادات المطلوبة

        -- بدء النشاط (Activity) باستخدام النية
        this.startActivity(i)
      end,

      onLongClickListener = {
        onLongClick = function(v)
          dlg.dismiss()
require 'import' import "android.content.*" i= Intent() .setComponent(ComponentName("com.android.settings", "com.android.settings.Settings$ZenAccessSettingsActivity")) this.startActivity(i)
          return true
        end,      },
      layout_width = "match_parent",
      layout_height = "wrap_content",
      background = "#ff000000",
      textColor = "#f0f8ff",
      textSize = "25sp",
      gravity = "center",
    },
  },

  {
    LinearLayout,
    orientation = 1,
    layout_width = "match_parent",
    {
      SeekBar,
      id = "soundSeekBar",
      onClick = function(v)
        service.click({{"%speakPhoneMode"}})
        dlg.dismiss()
      end,
      layout_width = "match_parent",
      layout_height = "80dp",
      contentDescription = "ring: ",
      background = "#ff000000",
    },
  },

  {
    LinearLayout,
    orientation = 1,
    layout_width = "match_parent",
    {
      SeekBar,
      id = "callSeekBar",
      onClick = function(v)
        service.click({{"%speakPhoneMode"}})
        dlg.dismiss()
      end,
      layout_width = "match_parent",
      layout_height = "80dp",
      contentDescription = "call: ",
      background = "#ff000000",
    },
  },

  {
    LinearLayout,
    orientation = 1,
    layout_width = "match_parent",
    {
      SeekBar,
      id = "mediaSeekBar",
      onClick = function(v)
        service.click({{"%speakPhoneMode"}})
        dlg.dismiss()
      end,
      layout_width = "match_parent",
      layout_height = "80dp",
      contentDescription = "media: ",
      background = "#ff000000",
    },
  },

  {
    LinearLayout,
    orientation = 1,
    layout_width = "match_parent",
    {
      SeekBar,
      id = "alarmSeekBar",
      onClick = function(v)
        service.click({{"%speakPhoneMode"}})
        dlg.dismiss()
      end,
      layout_width = "match_parent",
      layout_height = "80dp",
      contentDescription = "alarm: ",
      background = "#ff000000",
    },
  },

  {
    LinearLayout,
    orientation = 1,
    layout_width = "match_parent",
    {
      SeekBar,
      id = "notificationSeekBar",
      onClick = function(v)
        service.click({{"%speakPhoneMode"}})
        dlg.dismiss()
      end,
      layout_width = "match_parent",
      layout_height = "80dp",
      contentDescription = "notification: ",
      background = "#ff000000",
    },
  },

  {
    LinearLayout,
    orientation = 1,
    layout_width = "match_parent",
    {
      SeekBar,
      id = "accessibilitySeekBar",
      onClick = function(v)
        service.click({{"%speakPhoneMode"}})
        dlg.dismiss()
      end,
      layout_width = "match_parent",
      layout_height = "80dp",
      contentDescription = "accessibility: ",
      background = "#ff000000",
    },
  },

  {
    LinearLayout,
    orientation = 1,
    layout_width = "match_parent",
    gravity = "center_horizontal",
    {
      Button,
      id = "soundModeButton",
      text = "Activate vibration mode",
      layout_width = "match_parent",
      layout_height = "wrap_content",
      onClick = function(v)
        local buttonText = soundModeButton.getText()
        if buttonText == "Activate vibration mode" then
          setSoundMode("vibrate")
          soundModeButton.setText("Activate normal mode")
        elseif buttonText == "Activate normal mode" then
          setSoundMode("ring")
          service.playSoundTick()
          soundModeButton.setText("Activate silent mode")
        elseif buttonText == "Activate silent mode" then
          setSoundMode("silent")
          soundModeButton.setText("Activate vibration mode")
        end
      end,
      onLongClickListener = {
        onLongClick = function(v)
          dlg.dismiss()
          service.click({{"%speakPhoneMode"}})
          return true
        end,
      },
      textSize = "30sp",
      background = "#0000ff",
    },
  },
}

function initialize()
  dlg = LuaDialog()
  dlg.setView(loadlayout(layout))
  dlg.show()

  initializeSeekBar(soundSeekBar, AudioManager.STREAM_RING)
  initializeSeekBar(callSeekBar, AudioManager.STREAM_VOICE_CALL)
  initializeSeekBar(mediaSeekBar, AudioManager.STREAM_MUSIC)
  initializeSeekBar(alarmSeekBar, AudioManager.STREAM_ALARM)
  initializeSeekBar(notificationSeekBar, AudioManager.STREAM_NOTIFICATION)
  initializeSeekBar(accessibilitySeekBar, AudioManager.STREAM_ACCESSIBILITY)
end

initialize()